"use strict";
cc._RF.push(module, 'e1891J21/xDSbryyLRDn5DA', 'Shader');
// shader/Shader.ts

Object.defineProperty(exports, "__esModule", { value: true });
var Material_1 = require("./Material");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Shader = /** @class */ (function (_super) {
    __extends(Shader, _super);
    function Shader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.Target = null;
        _this._material = null;
        _this._startTime = 0;
        _this._time = 0;
        _this._curDis = 2;
        _this._startPos = { x: 0.5, y: 0.5 };
        _this._isPlayAni = false;
        return _this;
    }
    Shader.prototype.onLoad = function () {
        // 关闭动态图集
        if (cc.dynamicAtlasManager) {
            cc.dynamicAtlasManager.enabled = false;
        }
        this._material = new Material_1.default();
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this);
    };
    Shader.prototype.start = function () {
        if (this.Target) {
            var texture = this.Target.spriteFrame.getTexture();
            this._material.setTexture(texture);
            this._material.setSize(this.node.getContentSize().width, this.node.getContentSize().height);
            this._material.setTime(this._time);
            this._material.setStartPos(this._startPos.x, this._startPos.y);
            this._material.setCurDis(this._curDis);
            this._material.updateHash();
            var sp = this.Target;
            sp._material = this._material;
            sp._renderData._material = this._material;
        }
    };
    Shader.prototype.update = function (dt) {
        if (this._isPlayAni) {
            this._time = (Date.now() - this._startTime) / 1000;
            console.log(this._time);
            this._curDis = this._time * 0.2;
            if (this._curDis >= 2) {
                this._isPlayAni = false;
            }
            this._material.setTime(this._time);
            this._material.setStartPos(this._startPos.x, this._startPos.y);
            this._material.setCurDis(this._curDis);
        }
    };
    Shader.prototype.onTouchStart = function (event) {
        this._isPlayAni = true;
        this._startTime = Date.now();
        var touchPos = event.getLocation();
        touchPos = this.node.convertToNodeSpace(touchPos);
        this._startPos.x = touchPos.x / this.node.width;
        this._startPos.y = (this.node.height - touchPos.y) / this.node.height;
    };
    __decorate([
        property(cc.Sprite)
    ], Shader.prototype, "Target", void 0);
    Shader = __decorate([
        ccclass
    ], Shader);
    return Shader;
}(cc.Component));
exports.default = Shader;

cc._RF.pop();