(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/shader/Material.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'e5942lNh1JM3LYgU1Sl6drr', 'Material', __filename);
// shader/Material.ts

Object.defineProperty(exports, "__esModule", { value: true });
var shader = {
    name: 'test',
    defines: [],
    vert: "\nuniform mat4 viewProj;\nuniform mat4 model;\nattribute vec3 a_position;\nattribute vec2 a_uv0;\nvarying vec2 v_texCoord;\nvoid main () {\n    mat4 mvp;\n    mvp = viewProj * model;\n\n    vec4 pos = mvp * vec4(a_position, 1);\n    gl_Position = pos;\n    v_texCoord = a_uv0;\n}\n",
    frag: "\nuniform sampler2D iTexture;\nuniform vec2 startPos;\nuniform float curDis;\nuniform float time;\nuniform vec2 size;\nvarying vec2 v_texCoord;\n\nvoid main()\n{\n    vec2 dv = startPos - v_texCoord;\n    dv = dv * vec2(size.x/size.y, 1.0);\n    float dis = sqrt(dv.x * dv.x + dv.y * dv.y);\n    float disF = clamp(0.3 - abs(curDis - dis), 0.0, 1.0);\n    vec2 offset = normalize(dv) * sin(dis * 100.0 + time * 10.0) * 0.1 * disF;\n    vec2 uv = v_texCoord + offset;\n    gl_FragColor = texture2D(iTexture, uv);\n}\n",
};
var math = cc.vmath;
var renderEngine = cc.renderer.renderEngine;
var renderer = renderEngine.renderer;
var gfx = renderEngine.gfx;
var Material = renderEngine.Material;
var ShaderMaterial = /** @class */ (function (_super) {
    __extends(ShaderMaterial, _super);
    function ShaderMaterial() {
        var _this = _super.call(this, false) || this;
        // load the shader to program lib
        var rend = cc.renderer;
        rend._forward._programLib.define(shader.name, shader.vert, shader.frag, shader.defines);
        var pass = new renderer.Pass(shader.name);
        pass.setDepth(false, false);
        pass.setCullMode(gfx.CULL_NONE);
        pass.setBlend(gfx.BLEND_FUNC_ADD, gfx.BLEND_SRC_ALPHA, gfx.BLEND_ONE_MINUS_SRC_ALPHA, gfx.BLEND_FUNC_ADD, gfx.BLEND_SRC_ALPHA, gfx.BLEND_ONE_MINUS_SRC_ALPHA);
        var mainTech = new renderer.Technique(['transparent'], [
            { name: 'iTexture', type: renderer.PARAM_TEXTURE_2D },
            { name: 'size', type: renderer.PARAM_FLOAT2 },
            { name: 'time', type: renderer.PARAM_FLOAT },
            { name: 'startPos', type: renderer.PARAM_FLOAT2 },
            { name: 'curDis', type: renderer.PARAM_FLOAT },
        ], [pass]);
        _this._texture = null;
        _this._size = math.vec2.create();
        // need _effect to calculate hash
        _this._effect = _this.effect = new renderer.Effect([mainTech], {
            'size': _this._size
        }, []);
        _this._mainTech = mainTech;
        return _this;
    }
    ShaderMaterial.prototype.getTexture = function () {
        return this._texture;
    };
    ShaderMaterial.prototype.setTexture = function (val) {
        if (this._texture !== val) {
            this._texture = val;
            this._texture.update({
                // Adapt to shader
                flipY: false,
                // For load texture
                mipmap: false
            });
            this._effect.setProperty('iTexture', val.getImpl());
            this._texIds['iTexture'] = val.getId();
        }
    };
    ShaderMaterial.prototype.setSize = function (width, height) {
        this._size.x = width;
        this._size.y = height;
    };
    ShaderMaterial.prototype.setTime = function (time) {
        this._effect.setProperty('time', time);
    };
    ShaderMaterial.prototype.setStartPos = function (x, y) {
        var startPos = math.vec2.create();
        startPos.x = x;
        startPos.y = y;
        this._effect.setProperty('startPos', startPos);
    };
    ShaderMaterial.prototype.setCurDis = function (dis) {
        this._effect.setProperty('curDis', dis);
    };
    return ShaderMaterial;
}(Material));
exports.default = ShaderMaterial;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=Material.js.map
        